Qwt User's Guide: QwtPlotItem Class Reference

Qwt User's Guide 5.2.3

- Main Page
- Related Pages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions
QwtPlotItem Class Reference

`#include <qwt_plot_item.h>`

Inheritance diagram for QwtPlotItem:
[legend]

List of all members.

## Public Types
enum | ItemAttribute { Legend = 1, AutoScale = 2 }
enum | RenderHint { RenderAntialiased = 1 }
enum | RttiValues { Rtti_PlotItem = 0, Rtti_PlotGrid, Rtti_PlotScale, Rtti_PlotMarker, Rtti_PlotCurve, Rtti_PlotHistogram, Rtti_PlotSpectrogram, Rtti_PlotSVG, Rtti_PlotUserItem = 1000 }

## Public Member Functions
| QwtPlotItem (const QwtText &title=QwtText())
virtual | ~QwtPlotItem ()
void | attach (QwtPlot *plot)
virtual QwtDoubleRect | boundingRect () const
void | detach ()
virtual void | draw (QPainter *painter, const QwtScaleMap &xMap, const QwtScaleMap &yMap, const QRect &canvasRect) const =0
void | hide ()
QwtDoubleRect | invTransform (const QwtScaleMap &, const QwtScaleMap &, const QRect &) const
bool | isVisible () const
virtual void | itemChanged ()
virtual QWidget * | legendItem () const
QRect | paintRect (const QwtScaleMap &, const QwtScaleMap &) const
QwtPlot * | plot () const
virtual int | rtti () const
QwtDoubleRect | scaleRect (const QwtScaleMap &, const QwtScaleMap &) const
void | setAxis (int xAxis, int yAxis)
void | setItemAttribute (ItemAttribute, bool on=true)
void | setRenderHint (RenderHint, bool on=true)
void | setTitle (const QString &title)
void | setTitle (const QwtText &title)
virtual void | setVisible (bool)
void | setXAxis (int axis)
void | setYAxis (int axis)
void | setZ (double z)
void | show ()
bool | testItemAttribute (ItemAttribute) const
bool | testRenderHint (RenderHint) const
const QwtText & | title () const
QRect | transform (const QwtScaleMap &, const QwtScaleMap &, const QwtDoubleRect &) const
virtual void | updateLegend (QwtLegend *) const
virtual void | updateScaleDiv (const QwtScaleDiv &, const QwtScaleDiv &)
int | xAxis () const
int | yAxis () const
double | z () const
Public Member Functions inherited from QwtLegendItemManager
| QwtLegendItemManager ()
virtual | ~QwtLegendItemManager ()

## Detailed Description

Base class for items on the plot canvas.

A plot item is "something", that can be painted on the plot canvas, or only affects the scales of the plot widget. They can be categorized as:

- Representator
  A "Representator" is an item that represents some sort of data on the plot canvas. The different representator classes are organized according to the characteristics of the data:
  - QwtPlotMarker Represents a point or a horizontal/vertical coordinate
  - QwtPlotCurve Represents a series of points
  - QwtPlotSpectrogram ( QwtPlotRasterItem ) Represents raster data
  - ...

- Decorators
  A "Decorator" is an item, that displays additional information, that is not related to any data:
  - QwtPlotGrid
  - QwtPlotScaleItem
  - QwtPlotSvgItem
  - ...

Depending on the QwtPlotItem::ItemAttribute flags, an item is included into autoscaling or has an entry on the legnd.

Before misusing the existing item classes it might be better to implement a new type of plot item ( don't implement a watermark as spectrogram ). Deriving a new type of QwtPlotItem primarily means to implement the YourPlotItem::draw() method.

See also:
  The cpuplot example shows the implementation of additional plot items.

## Member Enumeration Documentation

enum QwtPlotItem::ItemAttribute

Plot Item Attributes

- Legend
  The item is represented on the legend.
- AutoScale
  The boundingRect() of the item is included in the autoscaling calculation.

See also:
  setItemAttribute(), testItemAttribute()

enum QwtPlotItem::RttiValues

Runtime type information.

RttiValues is used to cast plot items, without having to enable runtime type information of the compiler.

## Constructor & Destructor Documentation

QwtPlotItem::QwtPlotItem | ( | const QwtText & | title = `QwtText()` | ) |
| explicit

Constructor

Parameters:

  title | Title of the item

## Member Function Documentation

void QwtPlotItem::attach | ( | QwtPlot * | plot | ) |

Attach the item to a plot.

This method will attach a QwtPlotItem to the QwtPlot argument. It will first detach the QwtPlotItem from any plot from a previous call to attach (if necessary). If a NULL argument is passed, it will detach from any QwtPlot it was attached to.

Parameters:

  plot | Plot widget

See also:
  QwtPlotItem::detach()

QwtDoubleRect QwtPlotItem::boundingRect | ( |  | ) | const
| virtual

Returns:
  An invalid bounding rect: QwtDoubleRect(1.0, 1.0, -2.0, -2.0)

Reimplemented in QwtPlotCurve, QwtPlotMarker, QwtPlotSpectrogram, and QwtPlotSvgItem.

void QwtPlotItem::detach | ( |  | ) |
| inline

This method detaches a QwtPlotItem from any QwtPlot it has been associated with.

detach() is equivalent to calling attach( NULL )

See also:
  attach( QwtPlot* plot )

virtual void QwtPlotItem::draw | ( | QPainter * | painter,
|  | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap,
|  | const QRect & | canvasRect
| ) |  | const
| pure virtual

Draw the item.

Parameters:

  painter | Painter
  xMap | Maps x-values into pixel coordinates.
  yMap | Maps y-values into pixel coordinates.
  canvasRect | Contents rect of the canvas in painter coordinates

Implemented in QwtPlotCurve, QwtPlotMarker, QwtPlotScaleItem, QwtPlotSpectrogram, QwtPlotRasterItem, QwtPlotGrid, and QwtPlotSvgItem.

QwtDoubleRect QwtPlotItem::invTransform | ( | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap,
|  | const QRect & | rect
| ) |  | const

Transform a rectangle from paint to scale coordinates

Parameters:

  xMap | X map
  yMap | Y map
  rect | Rectangle in paint coordinates

Returns:
  Rectangle in scale coordinates

See also:
  transform()

bool QwtPlotItem::isVisible | ( |  | ) | const

Returns:
  true if visible

See also:
  setVisible(), show(), hide()

void QwtPlotItem::itemChanged | ( |  | ) |
| virtual

Update the legend and call QwtPlot::autoRefresh for the parent plot.

See also:
  updateLegend()

QWidget * QwtPlotItem::legendItem | ( |  | ) | const
| virtual

Allocate the widget that represents the item on the legend.

The default implementation is made for QwtPlotCurve and returns a QwtLegendItem(), but an item could be represented by any type of widget, by overloading legendItem() and updateLegend().

Returns:
  QwtLegendItem()

See also:
  updateLegend() QwtLegend()

Implements QwtLegendItemManager.

QRect QwtPlotItem::paintRect | ( | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap
| ) |  | const

Calculate the bounding paint rect of 2 maps.

Parameters:

  xMap | X map
  yMap | X map

Returns:
  Bounding rect of the scale maps

int QwtPlotItem::rtti | ( |  | ) | const
| virtual

Return rtti for the specific class represented. QwtPlotItem is simply a virtual interface class, and base classes will implement this method with specific rtti values so a user can differentiate them.

The rtti value is useful for environments, where the runtime type information is disabled and it is not possible to do a dynamic_cast<...>.

Returns:
  rtti value

See also:
  RttiValues

Reimplemented in QwtPlotCurve, QwtPlotSpectrogram, QwtPlotMarker, QwtPlotScaleItem, QwtPlotSvgItem, and QwtPlotGrid.

QwtDoubleRect QwtPlotItem::scaleRect | ( | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap
| ) |  | const

Calculate the bounding scale rect of 2 maps.

Parameters:

  xMap | X map
  yMap | X map

Returns:
  Bounding rect of the scale maps

void QwtPlotItem::setAxis | ( | int | xAxis,
|  | int | yAxis
| ) |  |

Set X and Y axis

The item will painted according to the coordinates its Axes.

Parameters:

  xAxis | X Axis
  yAxis | Y Axis

See also:
  setXAxis(), setYAxis(), xAxis(), yAxis()

void QwtPlotItem::setItemAttribute | ( | ItemAttribute | attribute,
|  | bool | on = `true`
| ) |  |

Toggle an item attribute

Parameters:

  attribute | Attribute type
  on | true/false

See also:
  testItemAttribute(), ItemAttribute

void QwtPlotItem::setRenderHint | ( | RenderHint | hint,
|  | bool | on = `true`
| ) |  |

Toggle an render hint

Parameters:

  hint | Render hint
  on | true/false

See also:
  testRenderHint(), RenderHint

void QwtPlotItem::setTitle | ( | const QString & | title | ) |

Set a new title

Parameters:

  title | Title

See also:
  title()

void QwtPlotItem::setTitle | ( | const QwtText & | title | ) |

Set a new title

Parameters:

  title | Title

See also:
  title()

void QwtPlotItem::setVisible | ( | bool | on | ) |
| virtual

Show/Hide the item

Parameters:

  on | Show if true, otherwise hide

See also:
  isVisible(), show(), hide()

void QwtPlotItem::setXAxis | ( | int | axis | ) |

Set the X axis

The item will painted according to the coordinates its Axes.

Parameters:

  axis | X Axis

See also:
  setAxis(), setYAxis(), xAxis()

void QwtPlotItem::setYAxis | ( | int | axis | ) |

Set the Y axis

The item will painted according to the coordinates its Axes.

Parameters:

  axis | Y Axis

See also:
  setAxis(), setXAxis(), yAxis()

void QwtPlotItem::setZ | ( | double | z | ) |

Set the z value.

Plot items are painted in increasing z-order.

Parameters:

  z | Z-value

See also:
  z(), QwtPlotDict::itemList()

bool QwtPlotItem::testItemAttribute | ( | ItemAttribute | attribute | ) | const

Test an item attribute

Parameters:

  attribute | Attribute type

Returns:
  true/false

See also:
  setItemAttribute(), ItemAttribute

bool QwtPlotItem::testRenderHint | ( | RenderHint | hint | ) | const

Test a render hint

Parameters:

  hint | Render hint

Returns:
  true/false

See also:
  setRenderHint(), RenderHint

const QwtText & QwtPlotItem::title | ( |  | ) | const

Returns:
  Title of the item

See also:
  setTitle()

QRect QwtPlotItem::transform | ( | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap,
|  | const QwtDoubleRect & | rect
| ) |  | const

Transform a rectangle

Parameters:

  xMap | X map
  yMap | Y map
  rect | Rectangle in scale coordinates

Returns:
  Rectangle in paint coordinates

See also:
  invTransform()

void QwtPlotItem::updateLegend | ( | QwtLegend * | legend | ) | const
| virtual

Update the widget that represents the item on the legend.

updateLegend() is called from itemChanged() to adopt the widget representing the item on the legend to its new configuration.

The default implementation is made for QwtPlotCurve and updates a QwtLegendItem(), but an item could be represented by any type of widget, by overloading legendItem() and updateLegend().

Parameters:

  legend | Legend

See also:
  legendItem(), itemChanged(), QwtLegend()

Implements QwtLegendItemManager.

Reimplemented in QwtPlotCurve.

void QwtPlotItem::updateScaleDiv | ( | const QwtScaleDiv & | ,
|  | const QwtScaleDiv & |
| ) |  |
| virtual

Update the item to changes of the axes scale division.

Update the item, when the axes of plot have changed. The default implementation does nothing, but items that depend on the scale division (like QwtPlotGrid()) have to reimplement updateScaleDiv()

Parameters:

  xScaleDiv | Scale division of the x-axis
  yScaleDiv | Scale division of the y-axis

See also:
  QwtPlot::updateAxes()

Reimplemented in QwtPlotScaleItem, and QwtPlotGrid.

double QwtPlotItem::z | ( |  | ) | const

Plot items are painted in increasing z-order.

Returns:
  setZ(), QwtPlotDict::itemList()